/*



*/
import java.io.*;
import java.nio.*;
import java.nio.channels.*;

public class Count_LinesMemoryMappedFile
{
   public static void main(String[] args) throws IOException, FileNotFoundException
   {
      // Memory map the first 2GB segment of the file.
    //FileChannel fc = new FileInputStream("data").getChannel();
      FileChannel fc = new RandomAccessFile("data", "r").getChannel();
      long fileSize = fc.size();
      ByteBuffer mbb = fc.map(FileChannel.MapMode.READ_ONLY, 0, Integer.MAX_VALUE);

      long byteCounter = 0;
      long lineCounter = 1;

      for (int i = 0; i < Integer.MAX_VALUE; ++i)
      {
         ++byteCounter;
         if ( '\n' == mbb.get() )
         {
            ++lineCounter;
         }
      }

      // Memory map the second segment of the file.
      int restOfFile = (int)(fileSize - Integer.MAX_VALUE - 1);
      mbb = fc.map(FileChannel.MapMode.READ_ONLY, 1L + Integer.MAX_VALUE, restOfFile);

      for (int i = 0; i < restOfFile; ++i)
      {
         ++byteCounter;
         if ( '\n' == mbb.get() )
         {
            ++lineCounter;
         }
      }

      System.out.printf("%,d bytes read from file\n", byteCounter);
      System.out.printf("%,d lines read from file\n", lineCounter);
      fc.close();
   }
}
