/*



*/
import java.io.*;

public class Count_Lines_v2_File
{
   private static final int BUFFERSIZE = 16 * 8192;

   public static void main(String[] args) throws IOException
   {
    //final InputStream is = new FileInputStream("data"); // no buffering
      final InputStream is = new BufferedInputStream(new FileInputStream("data")); // default buffering
    //final InputStream is = new BufferedInputStream(new FileInputStream("data"), BUFFERSIZE);

      int c;

      long byteCounter = 0;
      long lineCounter = 1;

      while ( (c = is.read()) != -1 ) // read one byte at a time
      {
         ++byteCounter;
         if ( '\n' == c )
         {
            ++lineCounter;
         }
      }

      System.out.printf("%,d bytes read from file\n", byteCounter);
      System.out.printf("%,d lines read from file\n", lineCounter);
      is.close();
   }
}
