/*



*/
import java.io.*;

public class Count_Lines_v4_File
{
   private static final int BUFFERSIZE = 16 * 8192;

   public static void main(String[] args) throws IOException
   {
      final InputStream is = new FileInputStream("data");

      byte[] c = new byte[BUFFERSIZE];
      int n;

      long byteCounter = 0;
      long lineCounter = 1;

      while ( (n = is.read(c)) != -1 )
      {
         byteCounter += n;
         for (int i = 0; i < n; i++)
         {
            if ( '\n' == c[i] )
            {
               ++lineCounter;
            }
         }
      }

      System.out.printf("%,d bytes read from file\n", byteCounter);
      System.out.printf("%,d lines read from file\n", lineCounter);
      is.close();
   }
}
