/*



*/

import java.io.*;

public class Count_Bytes_v4_File
{
   private static final int BUFFERSIZE = 16 * 8192;

   public static void main(String[] args) throws IOException
   {
      final InputStream is = new FileInputStream("data"); // no buffering

      byte[] c = new byte[BUFFERSIZE];
      int n;

      long byteCounter = 0;

      while ( (n = is.read(c)) != -1 ) // read one buffer full at a time
      {
         byteCounter += n;
      }

      System.out.printf("%,d bytes read from file\n", byteCounter);
      is.close();
   }
}
